<?php
/*
Template Name: Archives
*/
?>

<?php get_header(); ?>

<?php include (TEMPLATEPATH . '/left_sidebar.php'); ?>

<div id="content">

	<?php if (have_posts()) : ?>

		<?php while (have_posts()) : the_post(); ?>
		
			<div class="post" id="post-<?php the_ID(); ?>">
				<h2><a href="<?php the_permalink() ?>" rel="bookmark" title="Permanent Link to <?php the_title_attribute(); ?>"><?php the_title(); ?></a></h2>

					<div class="entry">
						
						<h3>Yearly Archive</h3>
							<ul>
								<?php wp_get_archives('type=yearly&show_post_count=1'); ?>
							</ul>

						<h3>Monthly Archive</h3>
							<ul>
								<?php wp_get_archives('type=monthly&show_post_count=1'); ?>
							</ul>

						<h3>Categories Archive</h3>
							<ul>
								<?php wp_list_categories('orderby=name&show_count=1&title_li='); ?>
							</ul>

						<h3>Tags Archive</h3>
							<ul>
								<li><?php wp_tag_cloud('smallest=8&largest=32&number=1000'); ?></li>
							</ul>

					</div>

			</div>
		
		<?php endwhile; ?>

		<?php else : ?>

			<h2 class="center">Not Found</h2>
			<p class="center">Sorry, but you are looking for something that isn't here.</p>
			<?php include (TEMPLATEPATH . "/searchform.php"); ?>

	<?php endif; ?>

</div>
	
<?php get_sidebar(); ?>
<?php get_footer(); ?>
